/*
pq쐬菇
PFCQRMatrix̃CX^X쐬
j
CQRMatrix qrArray;

QFQRŕ\f[^o^
j
qrArray.AddQRAscii( "http://www.spoonsoftware.com" );

RFxw肵QRR[h쐬
j
qrArray.MakeQRArray( COLLECTLEVEL_M );

SFGetModuleNumberĂяoA}gbNX̍sԍ擾
j
int iModuleNumber = qrArray.GetModuleNumber();

TFQ̃[vsAcf[^ɃANZX
j
for( int i=0 ; i<iModuleNumber ; i++ )
{
	for( int j=0 ; j<iModuleNumber ; j++ )
	{
		if( qrArray.GetModulePoint( j , i ) )
		{
			printf( "" );
		}
		else
		{
			printf( "@" );
		}
	}
}
*/

#ifndef _QRARRAY_H_
#define	_QRARRAY_H_

#include <list>
#include "QRDataElement.h"

using namespace std;

//x
#define	COLLECTLEVEL_L		(0x01)
#define	COLLECTLEVEL_M		(0x00)
#define	COLLECTLEVEL_Q		(0x03)
#define	COLLECTLEVEL_H		(0x02)

//QR쐬AG[ԍ
#define	QRERR_NOERROR				(0)
#define	QRERR_WRONG_COLLECTTYPE		(1)
#define QRERR_DATASIZE_LARGE		(2)
#define	QRERR_DONTSET_TYPENUMBER	(3)
#define	QRERR_DATAISNOT_NUMERIC		(4)
#define	QRERR_DATAISNOT_ALPHA		(5)
#define	QRERR_DATAISNOT_KANJI		(6)
#define	QRERR_WRONGDIRECT_BIT		(7)
#define	QRERR_DATABITCOUNT_FAILURE	(8)

//QRR[h̊ep^[
#define	QR_UNKNOWN				(-1)
#define QR_DATA_LIGHT			(0)
#define QR_DATA_DARK			(1)
#define	QR_COLLECT_LIGHT		(2)
#define	QR_COLLECT_DARK			(3)
#define	QR_POSITIONDITECT_LIGHT	(10)
#define	QR_POSITIONDITECT_DARK	(11)
#define	QR_POSITIONCHECK_LIGHT	(12)
#define	QR_POSITIONCHECK_DARK	(13)
#define	QR_TIMING_LIGHT			(14)
#define	QR_TIMING_DARK			(15)
#define	QR_TYPE_LIGHT			(20)
#define	QR_TYPE_DARK			(21)
#define	QR_MODEL_LIGHT			(22)
#define	QR_MODEL_DARK			(23)

#define	QR_MASK_LIGHT			(50)
#define	QR_MASK_DARK			(51)

class CQRMatrix
{
public:
	CQRMatrix();
	~CQRMatrix();

	//f[^Zbgn
	bool AddQRCharacters( const char * pcszString , int iCharacterType );

	bool MakeQRMatrix( int iCollectLevel , int & iErrorType );

	///////////////////////////////////////////////////////////
	///		QRR[ȟ^擾
	///		^1`40ƂȂ
	///////////////////////////////////////////////////////////
	inline
	int GetTypeNumber()
	{
		return m_iModelTypeIndex;
	}

	///////////////////////////////////////////////////////////
	///		W[擾
	///		W[}gbNX̏cEƂȂ
	///////////////////////////////////////////////////////////
	inline 
	int GetModuleNumber()
	{
		return m_iModuleNumber;
	}

	///////////////////////////////////////////////////////////
	///		w肳ꂽsɑΉ|Cgf[^擾
	///		߂lF@==falseF̈
	///				@==trueF×̈
	///////////////////////////////////////////////////////////
	inline
	bool IsDarkPoint( int iColumnIndex , int iRowIndex )
	{
		if( iColumnIndex < 0 || iColumnIndex >= m_iModuleNumber ||
			iRowIndex    < 0 || iRowIndex    >= m_iModuleNumber )
		{
			return false;
		}

		int iModulePointOrg;

		//̈̏ꍇ
		if( m_ppucQRMatrix[iColumnIndex][iRowIndex] < (char)0 )
		{
			iModulePointOrg = 0;
		}
		//ςݗ̈̏ꍇ
		else
		{
			iModulePointOrg = GetModulePoint( iColumnIndex , iRowIndex ) % 2;
		}

		//}XNȂf[^̏ꍇ
		if( m_ppucMaskMatrix[iColumnIndex][iRowIndex] == QR_UNKNOWN || m_iQRMaskPattern < 0 )
		{
			return (iModulePointOrg !=0 );
		}

		//}XNf[^̏ꍇ
		return (((GetMaskPoint( iColumnIndex , iRowIndex ) % 2) ^ iModulePointOrg) != 0 );
	}

protected:
	list<CQRDataElement> m_listQRData;
	void ReleaseAll();
	void ReleaseQRMatrix();
	void ReleaseMaskMatrix();
	void ReleaseData();
	void ReleaseError();

	bool GetDataBitNumber( int & iDataBit1_9 , int & iDataBit10_26 , int & iDataBit27_40 );

	bool CreateDataBits( int & iErrorType );
	unsigned char GetBitMask( int iBitNumber );
	bool SetTypeNumber(int iCollectLevel , int & iErrorType );
	bool InitModuleArea(int & iErrorType);
	bool SetPositionDitectPattern( int & iErrorType );
	bool SetPositionCheckPattern( int & iErrorType );
	bool SetTimingPattern( int & iErrorType );

	bool SetTypeInformation( bool bReserveOnly , int & iErrorType );
	bool SetModelInformation( int & iErrorType );

	bool CreateMaskPatternArea( int & iErrorType );

	bool AddDataBits( unsigned char ucData , int iBitNumber , int & iErrorType );
	bool AddDataBits( unsigned short usData , int & iErrorType );
	bool AddDataBits_Numeric( const char * pcszData , int iDataLength , int & iErrorType );
	bool AddDataBits_Alphabet( const char * pcszData , int iDataLength , int & iErrorType );
	bool AddDataBits_Ascii( const char * pcszData , int iDataLength , int & iErrorType );
	bool AddDataBits_Kanji( const char * pcszData , int iDataLength , int & iErrorType );

	bool OutputDataBits( int & iErrorType );
	unsigned char GetDataBit( int iBitIndex , bool bDataRequest );
	bool GetNextDataPutPoint( int & iColumnIndex , int & iRowIndex
									, bool & bFirstColumn
									, bool & bDirectionUp );

	bool DecideMaskPattern( int & iErrorType );
	int GetLostPoint_SeqModule( int iSeqBlock );
	int GetLostPoint_ModuleBlock( int iColumnIndex , int iRowIndex );
	int GetLostPoint_PositionDitect( int iColumnIndex , int iRowIndex );
	int GetLostPoint_BlackWhiteRatio( int iBlackPoint );

	bool CreateErrorCollectData( int & iErrorType );
	bool SeparateTotalNumber( int iSeparateCount , int iTotalNumber
							 , int & iFirstCount , int & iFirstNumber
							 , int & iSecondCount , int & iSecondNumber );

	///////////////////////////////////////////////////////////
	///		w肳ꂽsɑΉ|Cgf[^Zbg
	///////////////////////////////////////////////////////////
	inline
	bool SetModulePoint( int iColumnIndex , int iRowIndex , int iQRPoint )
	{
		if( iColumnIndex < 0 || iColumnIndex >= m_iModuleNumber ||
			iRowIndex    < 0 || iRowIndex    >= m_iModuleNumber )
		{
			return false;
		}
		m_ppucQRMatrix[iColumnIndex][iRowIndex] = iQRPoint;

		return true;
	}

	///////////////////////////////////////////////////////////
	///		w肳ꂽsɑΉ|Cgf[^擾
	///////////////////////////////////////////////////////////
	inline 
	int GetModulePoint( int iColumnIndex , int iRowIndex )
	{
		if( iColumnIndex < 0 || iColumnIndex >= m_iModuleNumber ||
			iRowIndex    < 0 || iRowIndex    >= m_iModuleNumber )
		{
			return QR_UNKNOWN;
		}

		return m_ppucQRMatrix[iColumnIndex][iRowIndex];
	}

	///////////////////////////////////////////////////////////
	///		wsÃ}XNp^[擾
	///////////////////////////////////////////////////////////
	inline 
	int GetMaskPoint( int iColumnIndex , int iRowIndex , int iQRMaskPattern = -1)
	{
		if( iQRMaskPattern < 0 )
		{
			iQRMaskPattern = m_iQRMaskPattern;
		}

		if( iQRMaskPattern < 0 || iQRMaskPattern > 7 )
		{
			return QR_UNKNOWN;
		}

		bool bMask;

		//dli,jȂ̂ŁAȂ悤ɕϊ
		int i = iRowIndex;
		int j = iColumnIndex;

		switch( iQRMaskPattern )
		{
		case 0:	bMask = ((i + j) % 2 == 0);							break;
		case 1:	bMask = (i % 2 == 0);								break;
		case 2:	bMask = (j % 3 == 0);								break;
		case 3:	bMask = ((i + j) % 3 == 0);							break;
		case 4:	bMask = (((i / 2) + (j / 3)) % 2 == 0 );			break;
		case 5:	bMask = ((i * j) % 2 + (i * j) % 3 == 0);			break;
		case 6:	bMask = (((i * j) % 2 + (i * j) % 3 ) % 2 == 0);	break;
		case 7:	bMask = (((i * j) % 3 + (i + j) % 2 ) % 2 == 0);	break;
		}

		return (bMask)?(QR_MASK_DARK):(QR_MASK_LIGHT);
	}

	bool GetExpressionMod( unsigned char *puszBaseData , int iBaseDataLength,
						   unsigned char *puszCoefficients ,
						   unsigned char *puszError , int iErrorLength );


protected:

	//QRf[^̃}gbNX{
	//evf͈ȉ̂ƂƂȂB
	//@< 0 F̈(QR_UNKNOWN)
	//  % 2 == 0 F̈
	//  % 2 != 0 F×̈
	//
	//@== 0 Ff[^̈ij(QR_DATA_LIGHT)
	//  == 1 Ff[^̈iÁj(QR_DATA_DARK)
	//  == 2 FG[̈ij(QR_COLLECT_LIGHT)
	//  == 3 FG[̈iÁj(QR_COLLECT_DARK)
	//  == 10Fʒuop^[ijip^[܂ށj(QR_POSITIONDITECT_LIGHT)
	//  == 11Fʒuop^[iÁjip^[܂ށj(QR_POSITIONDITECT_DARK)
	//  == 12Fʒu킹p^[ij(QR_POSITIONCHECK_LIGHT)
	//  == 13Fʒu킹p^[iÁj(QR_POSITIONCHECK_DARK)
	//  == 14F^C~Op^[ij(QR_TIMING_LIGHT)
	//  == 15F^C~Op^[iÁj(QR_TIMING_DARK)
	//  == 20F`ij(QR_TYPE_LIGHT)
	//  == 21F`iÁj(QR_TYPE_DARK)
	//  == 22F^ԏij(QR_MODEL_LIGHT)
	//  == 23F^ԏiÁj(QR_MODEL_DARK)
	char ** m_ppucQRMatrix;

	char ** m_ppucMaskMatrix;

	int m_iModuleNumber;
	
	int m_iModelTypeIndex;

	int m_iDataBitNumber;
	int m_iDataSizeNumber;
	unsigned char * m_pucData;

	int m_iErrorSizeNumber;
	unsigned char * m_pucError;

	int m_iQRMaskPattern;
};

#endif

